import { useState, useEffect } from 'react'
import { useParams, Link } from 'react-router-dom'

import client from '../client'


const Game = () => {
  const [game, setGame] = useState({})
  const { gameId } = useParams()

  useEffect(() => {
    client.getGame(gameId).then(game => setGame(game))
  }, [gameId])

  return (
    <div className="game">
      <h1>{game.name}</h1>

      <Link to={ `/game/${gameId}/chat` }><p>Game chat</p></Link>
    </div>
  )
}

export default Game
